//********************************************************************
//Website:  http://wch.cn
//Email:    tech@wch.cn
//Author:   W.ch 2007.6
//*******************************************************************

/* CH432QCH432TоƬ  Ӧò  V1.0 */
/* ѯʽȫ˫ͨѶMODEMźšԶӲƣڲʾ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include <absacc.h>
#pragma NOAREGS
#include "BASE.C"

/* CH432뵥ƬӲӿڲ,ӷʽѡһ */
//#include "PARA.C"        /* Ӳ׼8λڷʽӳ, CH432Q */
// #include "SPI_HW.C"      /* Ӳ׼4SPIڷʽ,CH432Q&CH432T */
#include "SPI_SW.C"         /* I/Oģ4SPIڷʽ, CH432Q&CH432T */
#include "SPI.C"            /* ӿӳ */

#define CH432_BPS   9600    /* CH4320ͨѶ */
#define CH432_BPS1  2400    /* CH4321ͨѶ */
#define Fpclk    1843200    /* ڲʱƵ    */
#define CH432_INT_WIRE   INT1 /* CH432INT# */
#define CH432_INT0_WIRE  (P1&1) /* ٶCH432INT0ӵP1.0 */
#define CH432_INT1_WIRE  (P1&2) /* ٶCH432INT1ӵP1.1 */

UINT8 SEND_STRING[ ] = { "444444555566666777788889999000009999995555555hello" };
UINT8 SEND_STRING1[ ] = { "33333333wwwwww" };
UINT8 idata buf[ 100 ];    /*  */
UINT8 xdata rcvbuf[ 64 ];    /*  */

void InitCH432( void )    /* ʼCH432 */
{
    UINT16 div;
    UINT8 DLL, DLM;
/**************************************************************************
          CH4320ļĴ

**************************************************************************/
    div = (Fpclk>>4)/CH432_BPS;
    DLM = div>>8;
    DLL = div&0xff;
    WriteCH432Data( CH432_LCR_PORT, BIT_LCR_DLAB );    /* DLABΪ1 */
    WriteCH432Data( CH432_DLL_PORT, DLL );    /* ò */
    WriteCH432Data( CH432_DLM_PORT, DLM );
    WriteCH432Data( CH432_FCR_PORT, BIT_FCR_RECVTG1 | BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽ */
    WriteCH432Data( CH432_LCR_PORT, BIT_LCR_WORDSZ1
                                  | BIT_LCR_WORDSZ0 );    /* ֳ8λ1λֹͣλУ */
    WriteCH432Data( CH432_IER_PORT, BIT_IER_IEMODEM | BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );  /* ʹж */
    WriteCH432Data( CH432_MCR_PORT, BIT_MCR_OUT2 | BIT_MCR_RTS | BIT_MCR_DTR );  /* ж,DTR,RTSΪ1 */

/**************************************************************************
          CH4321ļĴ

**************************************************************************/
    div = (Fpclk>>4)/CH432_BPS1;
    DLM = div>>8;
    DLL = div&0xff;
    WriteCH432Data( CH432_LCR1_PORT, BIT_LCR_DLAB );    /* DLABΪ1 */
    WriteCH432Data( CH432_DLL1_PORT, DLL );    /* ò */
    WriteCH432Data( CH432_DLM1_PORT, DLM );
    WriteCH432Data( CH432_FCR1_PORT, BIT_FCR_RECVTG1 | BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽ */
    WriteCH432Data( CH432_LCR1_PORT, BIT_LCR_PARMODE0
                                   | BIT_LCR_PAREN
                                   | BIT_LCR_STOPBIT
                                   | BIT_LCR_WORDSZ1
                                   | BIT_LCR_WORDSZ0 );    /* ֳ8λ2λֹͣλżУ */
    WriteCH432Data( CH432_IER1_PORT, BIT_IER_IEMODEM | BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );    /* ʹж */
    WriteCH432Data( CH432_MCR1_PORT, BIT_MCR_OUT2 | BIT_MCR_RTS | BIT_MCR_DTR );    /* жDTR,RTSΪ1 */
}

void UART0_SendByte( UINT8 dat )    /* CH4320һֽӳ */
{
    while( ( ReadCH432Data( CH432_LSR_PORT ) & BIT_LSR_THRE ) == 0 );     /* ȴݷ */
    WriteCH432Data( CH432_THR_PORT, dat );
}

UINT8 UART0_RcvByte()    /* CH4320һֽӳ */
{
    UINT8 Rcvdat;
    if( !( ReadCH432Data( CH432_LSR_PORT ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /*  b1-b4޴ */
    {
        while( ( ReadCH432Data( CH432_LSR_PORT ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */
        Rcvdat = ReadCH432Data( CH432_RBR_PORT );    /* ӽջĴ */
        return( Rcvdat );
    }
    else ReadCH432Data( CH432_RBR_PORT );    /* д */
}

void UART0_SendStr( UINT8 *str )    /* CH4320һַӳ */
{
    while( 1 )
    {
        if( *str == '\0' ) break;
        UART0_SendByte( *str++ );
    }
}

void UART1_SendByte( UINT8 dat )    /* CH4321һֽӳ */
{
    while( ( ReadCH432Data( CH432_LSR1_PORT ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */
    WriteCH432Data( CH432_THR1_PORT, dat );
}

UINT8 UART1_RcvByte()    /* CH4321һֽӳ */
{
    UINT8 Rcvdat;
    if( !( ReadCH432Data( CH432_LSR1_PORT ) & (BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {
        while( ( ReadCH432Data( CH432_LSR1_PORT ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */
        Rcvdat = ReadCH432Data( CH432_RBR1_PORT );    /* ӽջĴ */
        return( Rcvdat );
    }
    else ReadCH432Data( CH432_RBR1_PORT );    /* b1-b4д */
}

void  UART1_SendStr( UINT8 *str )    /* CH4321һַӳ */
{
    while(1)
    {
        if( *str == '\0' ) break;
        UART1_SendByte( *str++ );
    }
}

void  CH432Seril0Send( UINT8 *Data, UINT8 Num )    /* FIFO,CH4320Ͷֽӳ */
{
    do
    {
        while( ( ReadCH432Data( CH432_LSR_PORT ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */
        WriteCH432Data( CH432_THR_PORT, *Data++ );
    }
    while( --Num );
}

void  CH432Seril1Send( UINT8 *Data, UINT8 Num )    /* FIFO,CH4321Ͷֽӳ */
{
    do
    {
        while( ( ReadCH432Data( CH432_LSR1_PORT ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */
        WriteCH432Data( CH432_THR1_PORT, *Data++ );
    }
    while( --Num );
}

UINT8  CH432Seril0Rcv( UINT8 *buf )    /* FIFO,CH4320նֽӳ */
{
    UINT8 RcvNum = 0;
    if( !( ReadCH432Data( CH432_LSR_PORT ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {
        while( ( ReadCH432Data( CH432_LSR_PORT ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */
        do
        {
            *buf++ = ReadCH432Data( CH432_RBR_PORT );    /* ӽջĴ */
            RcvNum++;
        }
        while( ( ReadCH432Data( CH432_LSR_PORT ) & BIT_LSR_DATARDY ) == 0x01 );
    }
    else ReadCH432Data( CH432_RBR_PORT );
    return( RcvNum );
}

UINT8 CH432Seril1Rcv( UINT8 *buf )    /* FIFO,CH4321նֽӳ*/
{
    UINT8 RcvNum = 0;
    if( !( ReadCH432Data( CH432_LSR1_PORT ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {
         while( ( ReadCH432Data( CH432_LSR1_PORT ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */
         do
         {
              *buf++ = ReadCH432Data( CH432_RBR1_PORT );    /* ӽջĴ */
              RcvNum++;
         }
         while( ( ReadCH432Data( CH432_LSR1_PORT ) & BIT_LSR_DATARDY ) == 0x01 );
    }
    else ReadCH432Data( CH432_RBR1_PORT );
    return( RcvNum );
}

void  CH432UART0Send( UINT8 *Data, UINT8 Num )    /* FIFO,һ16ֽڣCH4320Ͷֽӳ */
{
    while( 1 )
    {
        while( ( ReadCH432Data( CH432_LSR_PORT ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */
        if( Num<= 16 )
        {
            WriteCH432Block( CH432_THR_PORT, Num, Data );
            break;
        }
        else
        {
            WriteCH432Block( CH432_THR_PORT, 16, Data );
            Num -= 16;
            Data += 16;
        }
    }
}

void CH432UART1Send( UINT8 *Data, UINT8 Num )    /* FIFO,һ16ֽڣCH4321Ͷֽӳ */
{
    while(1)
    {
        while( ( ReadCH432Data( CH432_LSR1_PORT ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */
        if( Num<= 16 )
        {
            WriteCH432Block( CH432_THR1_PORT, Num, Data );
            break;
        }
        else
        {
             WriteCH432Block( CH432_THR1_PORT, 16, Data );
             Num -= 16;
             Data += 16;
        }
    }
}

UINT8 UartDetectInterrupt( )    /* ѯCH432ж״̬ */
{
    UINT8 InterruptStatus;
    UINT8 RcvNum = 0;
    UINT8 s;
    UINT8 ModemStatus;
    while( 1 )
    {
        InterruptStatus = ReadCH432Data( CH432_IIR_PORT ) & ( ~ CH432_IIR_FIFOS_ENABLED );
        if( ( InterruptStatus & 0x01 ) )    /* ûжת1 */
        {
            InterruptStatus = ReadCH432Data( CH432_IIR1_PORT) & ( ~ CH432_IIR_FIFOS_ENABLED );    /* 1ж״̬ */
            if( ( InterruptStatus & 0x01 ) ) break;    /* ûж˳ */
            else
            {
                switch( InterruptStatus )
                {
                    case INT_NOINT:    /* ûж */
                        break;
                    case INT_THR_EMPTY:    /* ͱּĴж */
                        UART1_SendStr( SEND_STRING1 );
                        break;
                    case INT_RCV_SUCCESS:    /* ڽտж */
                        RcvNum = CH432Seril1Rcv( buf );
                        CH432Seril1Send( buf, RcvNum );
                        break;
                    case INT_RCV_LINES:    /* ·״̬ж */
                         ReadCH432Data( CH432_LSR1_PORT);
                        break;
                    case INT_RCV_OVERTIME:    /* ݳʱж */
                        RcvNum = CH432Seril1Rcv( buf );
                        CH432Seril1Send( buf, RcvNum );
                        break;
                    default:    /* ܷж */
                        break;
                }
            }
        } 
        else
        {
            switch( InterruptStatus )
            {
                case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH432Data( CH432_MSR_PORT );
                    WriteCH432Data( CH432_THR_PORT, ModemStatus );
                    UART0_SendStr( SEND_STRING1 );
                    if ( ModemStatus == 0x30 )    /* Modemźŷݱ仯 */
                    {
                        UART0_SendStr( SEND_STRING1 );
                    }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                    {
                        WriteCH432Data( CH432_THR_PORT, 0xAA );
                    }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                    {
                        s = ReadCH432Data( CH432_RBR_PORT );
                        WriteCH432Data( CH432_THR_PORT, s );
                    }
                    break;
                case INT_NOINT:    /* ûж */
                    break;
                case INT_THR_EMPTY:    /* ͱּĴж */
                    UART0_SendStr( SEND_STRING );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH432Seril0Rcv( buf );
                    UART0_SendByte( RcvNum );
                    CH432Seril0Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES :    /* ·״̬ж */
                    ReadCH432Data( CH432_LSR_PORT);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH432Seril0Rcv( buf );
                    UART0_SendByte( RcvNum );
                    CH432Seril0Send( buf, RcvNum );
                    break;
                default:    /* ܷж */
                    break;
            }
        }
    }
    return( InterruptStatus );
}

void Auto_HandFlow0_Ctrl( )    /* 0ԶӲ */
{
    WriteCH432Data( CH432_MCR_PORT, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCRĴAFERTSΪ1 */
}

void Auto_HandFlow1_Ctrl( )     /* 1ԶӲ*/
{
    WriteCH432Data( CH432_MCR1_PORT, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCR1ĴAFERTSΪ1 */
}

UINT8 Modem_Ctrl()    /* Modemͽӳ */
{
    UINT8 ModemStatus;
    UINT8 s;
    UINT8 InterruptStatus;
    while( 1 )
    {
        InterruptStatus = ReadCH432Data( CH432_IIR_PORT ) & ( ~ CH432_IIR_FIFOS_ENABLED );
        if( ( InterruptStatus & 0x01 ) ) continue;
        else
        {
            ModemStatus = ReadCH432Data( CH432_MSR_PORT );

            WriteCH432Data( CH432_THR_PORT, ModemStatus );
            if ( ModemStatus == 0x30 )    /* Modemźŷݱ仯 */
            {
                UART0_SendStr( SEND_STRING );
            }
            else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
            {
                WriteCH432Data( CH432_THR_PORT, 0xAA );
            }
            else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
            {
                s = ReadCH432Data( CH432_RBR_PORT );
                WriteCH432Data( CH432_THR_PORT, s );
            }
        }
    }
    return( ModemStatus );
}

void mInitSTDIO( )    /* ʼƬ ڲ鿴Ĵֵ */
{
    SCON = 0x50;
    PCON = 0x80;
    TMOD = 0x20;
    TH1 = 0xf3;  /* 24MHz, 9600bps */
    TR1 = 1;
    TI = 1;
}

void  CH432INT()    /* ѯCH432 INT0INT1ӳ */
{
    UINT8 InterruptStatus;
    UINT8 ModemStatus;
    UINT8 RcvNum, s;
    while( 1 )
    {
        if( CH432_INT1_WIRE )
        {
            InterruptStatus = ReadCH432Data( CH432_IIR1_PORT ) & ( ~ CH432_IIR_FIFOS_ENABLED );    /* 1ж״̬ */
            if( ( InterruptStatus & 0x01 ) ) continue;    /* ûж˳ */
            else
            {
                switch( InterruptStatus )
                {
                    case INT_NOINT:    /* ûж */
                        break;
                    case INT_THR_EMPTY:    /* ͱּĴж */
                        UART1_SendStr( SEND_STRING1 );
                        break;
                    case INT_RCV_SUCCESS :    /* ڽտж */
                        RcvNum = CH432Seril1Rcv( buf );
                        UART1_SendByte( RcvNum );
                        CH432Seril1Send( buf, RcvNum );
                        break;
                    case INT_RCV_LINES:    /* ·״̬ж */
                        ReadCH432Data( CH432_LSR1_PORT);
                        break;
                    case INT_RCV_OVERTIME:    /* ݳʱж */
                        RcvNum = CH432Seril1Rcv( buf );
                        UART1_SendByte( RcvNum );
                        CH432Seril1Send( buf, RcvNum );
                        break;
                    default:    /* ܷж */
                        break;
                }
            }
         }
        if( CH432_INT0_WIRE )
        {
            InterruptStatus=ReadCH432Data( CH432_IIR_PORT ) & ( ~ CH432_IIR_FIFOS_ENABLED );    /* 1ж״̬ */
            if( ( InterruptStatus & 0x01 ) ) continue;    /* ûж˳ */
            else
            {
                switch( InterruptStatus )
                {
                    case INT_MODEM_CHANGE:
                        ModemStatus = ReadCH432Data( CH432_MSR_PORT );
                        WriteCH432Data( CH432_THR_PORT, ModemStatus );
                        if ( ModemStatus == 0x30)    /* Modemźŷݱ仯 */
                        {
                            UART0_SendStr( SEND_STRING1 );
                        }
                        else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                        {
                            UART0_SendStr( SEND_STRING );
                        }
                        else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                        {
                            s= ReadCH432Data( CH432_RBR_PORT );
                            WriteCH432Data( CH432_THR_PORT, s );
                        }
                        break;
                    case INT_NOINT:    /* ûж */
                        break;
                    case INT_THR_EMPTY:    /* ͱּĴж */
                        WriteCH432Data( CH432_THR_PORT, 0xdd );
                        break;
                    case INT_RCV_SUCCESS:    /* ڽտж */
                        s=UART0_RcvByte();
                        UART0_SendByte( s );
                        break;
                    case INT_RCV_LINES:        /* ·״̬ж */
                        ReadCH432Data( CH432_LSR_PORT);
                        break;
                    case INT_RCV_OVERTIME:    /* ݳʱж */
                        RcvNum = CH432Seril0Rcv( buf );
                        UART0_SendByte( RcvNum );
                        CH432Seril0Send( buf, RcvNum );
                        break;
                    default:    /* ܷж */
                        break;
                }
             }
         }
    }
}


void main()
{
    UINT8 i,Status;
    UINT8 s = 0;
    CH432_PORT_INIT();
    #if 0
    mInitSTDIO( );    /* CH432뵥ƬӲȷ */
    Status = ReadCH432Data( CH432_IER_PORT );
    printf("%02X\n", Status );
    Status = ReadCH432Data( CH432_IIR1_PORT );
    printf("%02X\n", Status );
    Status = ReadCH432Data(CH432_IIR_PORT );
    printf("%02X\n", Status );
    Status = ReadCH432Data( CH432_FCR_PORT );
    printf("%02X\n", Status );
    Status = ReadCH432Data( CH432_MCR_PORT );
    printf("%02X\n", Status );
    Status = ReadCH432Data( CH432_LSR_PORT );
    printf("%02X\n", Status );
    Status = ReadCH432Data( CH432_MSR_PORT );
    printf("%02X\n", Status );
    #endif
    InitCH432( );
    
    UART0_SendByte( 0xAA );
    UART1_SendByte( 0xBB );
    for( i = 0; i < 30; i++ )
    {
        buf[ i ] = i;
    }
    CH432UART0Send( buf, 30 );
    CH432UART1Send( buf, 30 );
   
    #if 0
    Auto_HandFlow0_Ctrl( );
    Auto_HandFlow1_Ctrl( );
    #endif

    #if 0
    Modem_Ctrl();
    #endif

    #if 0
    s = CH432Seril0Rcv( buf );
    WriteCH432Data( CH432_THR_PORT, s );
    CH432Seril0Send( buf, s );
    #endif

    #if 0
    CH432INT();
    #endif
   
    while(1)
    {
        if( Query432Interrupt() ) UartDetectInterrupt();   /* жϽѯжϳ */
    }
    
}
