#ifdef __CX51__
#ifndef __C51__
#define __C51__    1
#endif
#endif

#ifdef __C51__
typedef bit bdata                     BOOL1;
#else
#define data
#define idata
#define xdata
typedef unsigned char                 BOOL1;
#endif
#ifndef    BOOL
typedef    unsigned char              BOOL;
#endif
#ifndef    TRUE
#define    TRUE 1
#define    FALSE 0
#endif
#ifndef UINT8
typedef unsigned char                 UINT8;
#endif
#ifndef UINT16
typedef unsigned short                UINT16;
#endif
#ifndef UINT32
typedef unsigned long                 UINT32;
#endif
#ifndef PUINT8
typedef unsigned char                 *PUINT8;
#endif
#ifndef PUINT16
typedef unsigned short                *PUINT16;
#endif
#ifndef PUINT32
typedef unsigned long                 *PUINT32;
#endif
#ifndef UINT8V
typedef unsigned char volatile        UINT8V;
#endif

/******************************************************************************************/

/* оƬ */
/* CH4320Ĵַ */

#define REG_RBR_ADDR        0x00      /* 0ջĴַ */
#define REG_THR_ADDR        0x00      /* 0ͱּĴַ */
#define REG_IER_ADDR        0x01      /* 0жʹܼĴַ */
#define REG_IIR_ADDR        0x02      /* 0жʶĴַ */
#define REG_FCR_ADDR        0x02      /* 0FIFOƼĴַ */
#define REG_LCR_ADDR        0x03      /* 0·ƼĴַ */
#define REG_MCR_ADDR        0x04      /* 0MODEMƼĴַ */
#define REG_LSR_ADDR        0x05      /* 0·״̬Ĵַ */
#define REG_MSR_ADDR        0x06      /* 0MODEM״̬Ĵַ */
#define REG_SCR_ADDR        0x07      /* 0ûɶĴַ */
#define REG_DLL_ADDR        0x00      /* ʳ8λֽڵַ */
#define REG_DLM_ADDR        0x01      /* ʳ8λֽڵַ */

/* CH4321Ĵַ */

#define REG_RBR1_ADDR       0x08      /* 1ջĴַ */
#define REG_THR1_ADDR       0x08      /* 1ͱּĴַ */
#define REG_IER1_ADDR       0x09      /* 1жʹܼĴַ */
#define REG_IIR1_ADDR       0x0A      /* 1жʶĴַ */
#define REG_FCR1_ADDR       0x0A      /* 1FIFOƼĴַ */
#define REG_LCR1_ADDR       0x0B      /* 1·ƼĴַ */
#define REG_MCR1_ADDR       0x0C      /* 1MODEMƼĴַ */
#define REG_LSR1_ADDR       0x0D      /* 1·״̬Ĵַ */
#define REG_MSR1_ADDR       0x0E      /* 1MODEM״̬Ĵַ */
#define REG_SCR1_ADDR       0x0F      /* 1ûɶĴַ */
#define REG_DLL1_ADDR       0x08      /* ʳ8λֽڵַ */
#define REG_DLM1_ADDR       0x09      /* ʳ8λֽڵַ */

/* IERĴλ */

#define BIT_IER_RESET       0x80      /* λ1λô */
#define BIT_IER_LOWPOWER    0x40      /* λΪ1رոôڵڲ׼ʱ */
#define BIT_IER_SLP         0x20      /* 0SLP,Ϊ1رʱ */
#define BIT_IER1_CK2X       0x20      /* 1CK2X,Ϊ1ǿƽⲿʱź2ƵΪڲ׼ʱ */
#define BIT_IER_IEMODEM     0x08      /* λΪ1MODEM״̬仯ж */
#define BIT_IER_IELINES     0x04      /* λΪ1·״̬ж */
#define BIT_IER_IETHRE      0x02      /* λΪ1ͱּĴж */
#define BIT_IER_IERECV      0x01      /* λΪ1յж */

/* IIRĴλ */

#define BIT_IIR_FIFOENS1    0x80
#define BIT_IIR_FIFOENS0    0x40      /* 2λΪ1ʾFIFO */

/* жͣ0001ûжϣ0110·״̬жϣ0100ݿжϣ
1100ݳʱжϣ0010THRĴжϣ0000MODEM仯ж */
#define BIT_IIR_IID3        0x08
#define BIT_IIR_IID2        0x04
#define BIT_IIR_IID1        0x02
#define BIT_IIR_NOINT       0x01

/* FCRĴλ */

/* 㣺 00Ӧ1ֽڣ01Ӧ4ֽڣ10Ӧ8ֽڣ11Ӧ14ֽ */
#define BIT_FCR_RECVTG1     0x80      /* FIFOжϺԶӲƵĴ */
#define BIT_FCR_RECVTG0     0x40      /* FIFOжϺԶӲƵĴ */

#define BIT_FCR_TFIFORST    0x04      /* λ1շFIFOе */
#define BIT_FCR_RFIFORST    0x02      /* λ1սFIFOе */
#define BIT_FCR_FIFOEN      0x01      /* λ1FIFO,Ϊ0FIFO */

/* LCRĴλ */

#define BIT_LCR_DLAB        0x80      /* Ϊ1ܴȡDLLDLMΪ0ܴȡRBR/THR/IER */
#define BIT_LCR_BREAKEN     0x40      /* Ϊ1ǿƲBREAK·*/

/* УʽPARENΪ1ʱ00У飬01żУ飬10־λMARK1)11հλSPACE0) */
#define BIT_LCR_PARMODE1    0x20      /* żУλʽ */
#define BIT_LCR_PARMODE0    0x10      /* żУλʽ */

#define BIT_LCR_PAREN       0x08      /* Ϊ1ʱͽУżУλ */
#define BIT_LCR_STOPBIT     0x04      /* Ϊ1ֹͣλ,Ϊ0һֹͣλ */

/* ֳȣ005λ016λ107λ118λ */
#define BIT_LCR_WORDSZ1     0x02      /* ֳ */
#define BIT_LCR_WORDSZ0     0x01

/* MCRĴλ */

#define BIT_MCR_AFE         0x20      /* Ϊ1CTSRTSӲԶ */
#define BIT_MCR_LOOP        0x10      /* Ϊ1ʹڲ·Ĳģʽ */
#define BIT_MCR_OUT2        0x08      /* Ϊ1ôڵж */
#define BIT_MCR_OUT1        0x04      /* ΪûMODEMλ */
#define BIT_MCR_RTS         0x02      /* λΪ1RTSЧ */
#define BIT_MCR_DTR         0x01      /* λΪ1DTRЧ */

/* LSRĴλ */

#define BIT_LSR_RFIFOERR    0x80      /* Ϊ1ʾڽFIFOдһ */
#define BIT_LSR_TEMT        0x40      /* Ϊ1ʾTHRTSRȫ */
#define BIT_LSR_THRE        0x20      /* Ϊ1ʾTHR*/
#define BIT_LSR_BREAKINT    0x10      /* λΪ1ʾ⵽BREAK· */
#define BIT_LSR_FRAMEERR    0x08      /* λΪ1ʾȡ֡ */
#define BIT_LSR_PARERR      0x04      /* λΪ1ʾżУ */
#define BIT_LSR_OVERR       0x02      /* Ϊ1ʾFIFO */
#define BIT_LSR_DATARDY     0x01      /* λΪ1ʾFIFOнյ */

/* MSRĴλ */

#define BIT_MSR_DCD         0x80      /* λΪ1ʾDCDЧ */
#define BIT_MSR_RI          0x40      /* λΪ1ʾRIЧ */
#define BIT_MSR_DSR         0x20      /* λΪ1ʾDSRЧ */
#define BIT_MSR_CTS         0x10      /* λΪ1ʾCTSЧ */
#define BIT_MSR_DDCD        0x08      /* λΪ1ʾDCD״̬仯 */
#define BIT_MSR_TERI        0x04      /* λΪ1ʾRI״̬仯 */
#define BIT_MSR_DDSR        0x02      /* λΪ1ʾDSR״̬仯 */
#define BIT_MSR_DCTS        0x01      /* λΪ1ʾCTS״̬仯 */

/* ж״̬ */

#define INT_NOINT           0x01      /* ûж */
#define INT_THR_EMPTY       0x02      /* THRж */
#define INT_RCV_OVERTIME    0x0C      /* ճʱж */
#define INT_RCV_SUCCESS     0x04      /* ݿж */
#define INT_RCV_LINES       0x06      /* ·״̬ж */
#define INT_MODEM_CHANGE    0x00      /* MODEM仯ж */

#define CH432_IIR_FIFOS_ENABLED 0xC0  /* FIFO */

/*ֳֹͣλУλ
WriteCH432Data( CH432_LCR_PORT, BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x03,ֳ8λ1λֹͣλ,żУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x0F,ֳ8λ2λֹͣλ,У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x0E,ֳ7λ2λֹͣλУ


WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x0D,ֳ6λ2λֹͣλУ


WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x0C,ֳ5λ2λֹͣλУ


WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x1F,ֳ8λ2λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x1E,ֳ7λ2λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x1D,ֳ6λ2λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x1C,ֳ5λ2λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x2F,ֳ8λ2λֹͣλ־1У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x2E,ֳ7λ2λֹͣλ־1У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x2D,ֳ6λ2λֹͣλ־1У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x2C,ֳ5λ2λֹͣλ־1У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x3F,ֳ8λ2λֹͣλհ0У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x3E,ֳ7λ2λֹͣλհ0У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x3D,ֳ6λ2λֹͣλհ0У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE1
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x3C,ֳ5λ2λֹͣλհ0У

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x1B,ֳ8λ1λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_WORDSZ1 );      // 0x1A,ֳ7λ1λֹͣλżУ


WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_WORDSZ0 );      // 0x19,ֳ6λ1λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN );      // 0x18,ֳ5λ1λֹͣλżУ

WriteCH432Data( CH432_LCR_PORT, BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x07,ֳ8λ2λֹͣλ,żУ
*/

