// *******************************************************************
//Website:  http://wch.cn
//Email:    tech@wch.cn
//Author:   W.ch 2007.6
// *******************************************************************

/**********************************************************************
        CH4320ļĴַ
***********************************************************************/

#define CH432_RBR_PORT     REG_RBR_ADDR     /* ٶCH432ջĴ0I/Oַ */
#define CH432_THR_PORT     REG_THR_ADDR     /* ٶCH432ͱּĴ0I/Oַ */
#define CH432_IER_PORT     REG_IER_ADDR     /* ٶCH432жʹܼĴ0I/Oַ */
#define CH432_IIR_PORT     REG_IIR_ADDR     /* ٶCH432жʶĴ0I/Oַ */
#define CH432_FCR_PORT     REG_FCR_ADDR     /* ٶCH432FIFOƼĴ0I/Oַ */
#define CH432_LCR_PORT     REG_LCR_ADDR     /* ٶCH432·ƼĴ0I/Oַ */
#define CH432_MCR_PORT     REG_MCR_ADDR     /* ٶCH432MODEMƼĴ0I/Oַ */
#define CH432_LSR_PORT     REG_LSR_ADDR     /* ٶCH432·״̬Ĵ0I/Oַ */
#define CH432_MSR_PORT     REG_MSR_ADDR     /* ٶCH432MODEM״̬Ĵ0I/Oַ */
#define CH432_SCR_PORT     REG_SCR_ADDR     /* ٶCH432ûɶĴ0I/Oַ */
#define CH432_DLL_PORT     REG_DLL_ADDR
#define CH432_DLM_PORT     REG_DLM_ADDR

/**************************************************************************
        CH4321ļĴַ
**************************************************************************/

#define CH432_RBR1_PORT    REG_RBR1_ADDR    /* ٶCH432ջĴ1I/Oַ */
#define CH432_THR1_PORT    REG_THR1_ADDR    /* ٶCH432ͱּĴ1I/Oַ */
#define CH432_IER1_PORT    REG_IER1_ADDR    /* ٶCH432жʹܼĴ1I/Oַ */
#define CH432_IIR1_PORT    REG_IIR1_ADDR    /* ٶCH432жʶĴ1I/Oַ */
#define CH432_FCR1_PORT    REG_FCR1_ADDR    /* ٶCH432FIFOƼĴ1I/Oַ */
#define CH432_LCR1_PORT    REG_LCR1_ADDR    /* ٶCH432·ƼĴ1I/Oַ */
#define CH432_MCR1_PORT    REG_MCR1_ADDR    /* ٶCH432MODEMƼĴ1I/Oַ */
#define CH432_LSR1_PORT    REG_LSR1_ADDR    /* ٶCH432·״̬Ĵ1I/Oַ */
#define CH432_MSR1_PORT    REG_MSR1_ADDR    /* ٶCH432MODEM״̬Ĵ1I/Oַ */
#define CH432_SCR1_PORT    REG_SCR1_ADDR    /* ٶCH432ûɶĴ1I/Oַ */
#define CH432_DLL1_PORT    REG_DLL1_ADDR
#define CH432_DLM1_PORT    REG_DLM1_ADDR

UINT8 ReadCH432Data( UINT8 mAddr )    /* ָĴȡ */
{
    UINT8 d;
    Spi432Start( ( mAddr<<2 ) &0xFD );    /* λ5-2Ϊǰַλ1Ϊ0 */
    d = Spi432InByte( );
    Spi432Stop( );
    return( d );
}

void WriteCH432Data( UINT8 mAddr, UINT8 mData )    /* ָĴд */
{
    Spi432Start( ( mAddr<<2 ) | 0x02 );    /* λ5-2Ϊǰַλ1Ϊ1д */
    Spi432OutByte( mData );
    Spi432Stop( );
}

void WriteCH432Block( UINT8 mAddr, UINT8 mLen, PUINT8 mBuf )    /* ָʼַдݿ */
{
    while ( mLen -- ) WriteCH432Data( mAddr, *mBuf++ );
}


